/*
Copyright (C)2008, IBM, Inc. All rights reserved. 
IBM, Inc. owns the copyright and other intellectual 
property rights in this software. Duplication or use of the 
Software is not permitted except as expressly provided in a 
written agreement between your company and IBM, Inc.
*/

#include "bf_agent.h"

static char MODULE_NAME[]="bfpwdpromptloc";
static int DEBUG=1;

static char* getName(void) {
	return (char*)&MODULE_NAME;
}

static char* getPassword (const char* prop, const char* location) {
	char* password;

	password = (char*) malloc(512);
	printf("Enter password for property \"%s->%s\": ", prop, location);
	/* the leading space before the %c ignores space characters in the input */
	scanf("%s", password );
	return password;		
}

static passwd_locator_ops my_ops = {
		&getName,
        &getPassword
};


#ifdef WIN32
__declspec(dllexport)
#endif 
passwd_locator_ops* bfpwdpromptloc_init(void) {
    return &my_ops;
}

