/*
Copyright (C)2007-2008, IBM, Inc. All rights reserved. 
IBM, Inc. owns the copyright and other intellectual 
property rights in this software. Duplication or use of the 
Software is not permitted except as expressly provided in a 
written agreement between your company and IBM, Inc.
*/

#ifndef BUFFER_H
#define BUFFER_H

#include "bf_agent.h"

#ifdef HAVE_MALLOC_H
#include <malloc.h>
#endif
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

int format_message(char *, const char *, ...);

char *buffer_format(
		size_t *lenptr,
		const char *bucket,
		const char *msgkey,
		const char *fmt,
		...);

char *buffer_format_v(
		size_t *lenptr,
		const char *bucket,
		const char *msgkey,
		const char *fmt,
		va_list va);

int buffer_ensure_capacity(char **bufptr, size_t *lenptr, size_t size);
#define BUFFER_ENSURE_CAPACITY(bufptr, lenptr, size) do { \
	if (!buffer_ensure_capacity(bufptr, lenptr, size)) { \
		goto out_of_memory; \
	} \
} while (0)


#ifdef ZOS
int buffer_append_escaped_zos(
		char **bufptr,
		size_t *blenptr,
		size_t *bidxptr,
		const char *s);
#define buffer_append_escaped buffer_append_escaped_zos
#else /* !ZOS */
int buffer_append_escaped_utf8(
		char **bufptr,
		size_t *blenptr,
		size_t *bidxptr,
		const char *s);
#define buffer_append_escaped buffer_append_escaped_utf8
#endif /* ZOS/! */

#endif /* BUFFER_H */

