/*
Copyright (C)2007-2008, IBM, Inc. All rights reserved. 
IBM, Inc. owns the copyright and other intellectual 
property rights in this software. Duplication or use of the 
Software is not permitted except as expressly provided in a 
written agreement between your company and IBM, Inc.
*/

#define CONVERT_C
#include "bf_agent.h"

#ifdef ZOS

/* Hardcoded transcoder for ISO 8859-1 -> IBM-1047 */
static const char *BF_ATOE =
	"\x00\x01\x02\x03\x37\x2D\x2E\x2F\x16\x05\x15\x0B\x0C\x0D\x0E\x0F"
	"\x10\x11\x12\x13\x3C\x3D\x32\x26\x18\x19\x3F\x27\x1C\x1D\x1E\x1F"
	"\x40\x5A\x7F\x7B\x5B\x6C\x50\x7D\x4D\x5D\x5C\x4E\x6B\x60\x4B\x61"
	"\xF0\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\x7A\x5E\x4C\x7E\x6E\x6F"
	"\x7C\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xD1\xD2\xD3\xD4\xD5\xD6"
	"\xD7\xD8\xD9\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xAD\xE0\xBD\x5F\x6D"
	"\x79\x81\x82\x83\x84\x85\x86\x87\x88\x89\x91\x92\x93\x94\x95\x96"
	"\x97\x98\x99\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xC0\x4F\xD0\xA1\x07"
	"\x20\x21\x22\x23\x24\x25\x06\x17\x28\x29\x2A\x2B\x2C\x09\x0A\x1B"
	"\x30\x31\x1A\x33\x34\x35\x36\x08\x38\x39\x3A\x3B\x04\x14\x3E\xFF"
	"\x41\xAA\x4A\xB1\x9F\xB2\x6A\xB5\xBB\xB4\x9A\x8A\xB0\xCA\xAF\xBC"
	"\x90\x8F\xEA\xFA\xBE\xA0\xB6\xB3\x9D\xDA\x9B\x8B\xB7\xB8\xB9\xAB"
	"\x64\x65\x62\x66\x63\x67\x9E\x68\x74\x71\x72\x73\x78\x75\x76\x77"
	"\xAC\x69\xED\xEE\xEB\xEF\xEC\xBF\x80\xFD\xFE\xFB\xFC\xBA\xAE\x59"
	"\x44\x45\x42\x46\x43\x47\x9C\x48\x54\x51\x52\x53\x58\x55\x56\x57"
	"\x8C\x49\xCD\xCE\xCB\xCF\xCC\xE1\x70\xDD\xDE\xDB\xDC\x8D\x8E\xDF";

/* Hardcoded transcoder for IBM-1047 -> ISO 8859-1 */
static const char *BF_ETOA =
	"\x00\x01\x02\x03\x9C\x09\x86\x7F\x97\x8D\x8E\x0B\x0C\x0D\x0E\x0F"
	"\x10\x11\x12\x13\x9D\x0A\x08\x87\x18\x19\x92\x8F\x1C\x1D\x1E\x1F"
	"\x80\x81\x82\x83\x84\x85\x17\x1B\x88\x89\x8A\x8B\x8C\x05\x06\x07"
	"\x90\x91\x16\x93\x94\x95\x96\x04\x98\x99\x9A\x9B\x14\x15\x9E\x1A"
	"\x20\xA0\xE2\xE4\xE0\xE1\xE3\xE5\xE7\xF1\xA2\x2E\x3C\x28\x2B\x7C"
	"\x26\xE9\xEA\xEB\xE8\xED\xEE\xEF\xEC\xDF\x21\x24\x2A\x29\x3B\x5E"
	"\x2D\x2F\xC2\xC4\xC0\xC1\xC3\xC5\xC7\xD1\xA6\x2C\x25\x5F\x3E\x3F"
	"\xF8\xC9\xCA\xCB\xC8\xCD\xCE\xCF\xCC\x60\x3A\x23\x40\x27\x3D\x22"
	"\xD8\x61\x62\x63\x64\x65\x66\x67\x68\x69\xAB\xBB\xF0\xFD\xFE\xB1"
	"\xB0\x6A\x6B\x6C\x6D\x6E\x6F\x70\x71\x72\xAA\xBA\xE6\xB8\xC6\xA4"
	"\xB5\x7E\x73\x74\x75\x76\x77\x78\x79\x7A\xA1\xBF\xD0\x5B\xDE\xAE"
	"\xAC\xA3\xA5\xB7\xA9\xA7\xB6\xBC\xBD\xBE\xDD\xA8\xAF\x5D\xB4\xD7"
	"\x7B\x41\x42\x43\x44\x45\x46\x47\x48\x49\xAD\xF4\xF6\xF2\xF3\xF5"
	"\x7D\x4A\x4B\x4C\x4D\x4E\x4F\x50\x51\x52\xB9\xFB\xFC\xF9\xFA\xFF"
	"\x5C\xF7\x53\x54\x55\x56\x57\x58\x59\x5A\xB2\xD4\xD6\xD2\xD3\xD5"
	"\x30\x31\x32\x33\x34\x35\x36\x37\x38\x39\xB3\xDB\xDC\xD9\xDA\x9F";


void convert_atoe(char *in) {
	while (*in != 0x00) {
		*in = BF_ATOE[(int)(unsigned int)(*in)];
		++in;
	}
}

void convert_atoe_l(char *in, size_t len) {
	while (len > 0) {
		*in = BF_ATOE[(int)(unsigned int)(*in)];
		++in;
		--len;
	}
}

void convert_etoa(char *in) {
	while (*in != '\0') {
		*in = BF_ETOA[(int)(unsigned int)(*in)];
		++in;
	}
}

void convert_etoa_l(char *in, size_t len) {
	while (len > 0) {
		*in = BF_ETOA[(int)(unsigned int)(*in)];
		++in;
		--len;
	}
}

#endif /* ZOS */

size_t convert_utf8_find_boundary(const char *in, size_t inlen)
{
	register uint8_t c;
	size_t len = inlen;
#ifdef ZOS
	char p[3];
#endif /* ZOS */

	if (inlen <= 0)
		return 0;

	if (inlen > 3) {
		in = &in[inlen - 3];
		len = 3;
	}

#ifdef ZOS
	memcpy(p, in, len);
	convert_etoa_l(p, len);
	in = p;
#endif /* ZOS */

	/* We can process the entire buffer in all cases except where
	 * the buffer ends in an incomplete (but so far valid) multi-byte
	 * sequence.  That is, any of these cases:
	 *   ...     ...     ...    C0-F4
	 *   ...     ...    E0-F4   80-BF
	 *   ...    F0-F4   80-BF   80-BF
	 * For each of these cases, the character boundary is immediately
	 * before the first character of the match.
	 */

	/* Check the last byte ... */
	if ((c = (uint8_t)(in[len - 1])) >= 0x80) {
		if (c >= 0xC0) return (c >= 0xF5) ? inlen : (inlen - 1);

		/* It was an extension byte, so check the next-to-last byte ... */
		if (len >= 2 && (c = (uint8_t)(in[len - 2])) >= 0x80) {
			if (c >= 0xE0) return (c >= 0xF5) ? inlen : (inlen - 2);
			if (c >= 0xC0) return inlen;

			/* It was an extension byte, so yet another check ... */
			if (len >= 3 && (c = (uint8_t)(in[len - 3])) >= 0x80) {
				if (c >= 0xF0) return (c >= 0xF5) ? inlen : (inlen - 3);
				if (c >= 0xC0) return inlen;
			}
		}
	}

	return inlen;
}

#define UTF8_REPLACE (0x3F)
#define UTF8_IS_EXT(c) (((c) & 0xC0) == 0x80)
unsigned int convert_utf8_clean(char *buf, size_t len, int replace)
{
	unsigned int errors = 0;
	uint8_t *p = (uint8_t *)buf;
	uint8_t *stop = (uint8_t *)&buf[len];

#ifdef ZOS
	convert_etoa_l(buf, len);
#endif /* ZOS */

	while (p < stop) {
		/* ASCII */
		if (*p < 0x80) {
			++p;
			continue;
		}

		/* This catches:
		 * - extension byte that isn't part of a well-formed sequence
		 * - overlong encoding of ASCII as 2-byte
		 * - >4 byte sequence, which has to be overlong or exceed U+10FFFF
		 */
		if (*p < 0xC2 || *p >= 0xF5)
			goto malformed;

		/* 2-byte sequence */
		if (*p < 0xE0) {
			/* incomplete 2-byte sequence */
			if (p + 2 > stop || !UTF8_IS_EXT(p[1]))
				goto malformed;

			/* well-formed 2-byte sequence */
			p += 2;
			continue;
		}

		/* 3-byte sequence */
		if (*p < 0xF0) {
			/* This catches:
			 * - incomplete 3-byte sequence
			 * - overlong encoding of ASCII or 2-byte code point
			 * - code point is a UTF-16 surrogate (U+D800 - U+DFFF)
			 * - code point is U+FFFE or U+FFFF
			 */
			if (p + 3 > stop || !UTF8_IS_EXT(p[1]) || !UTF8_IS_EXT(p[2])
					|| (*p == 0xE0 && p[1] < 0xA0)
					|| (*p == 0xED && p[1] >= 0xA0)
					|| (*p == 0xEF && p[1] == 0xBF && p[2] >= 0xBE))
				goto malformed;

			/* well-formed 3-byte sequence */
			p += 3;
			continue;
		}

		/* 4-byte sequence. */
		/* This catches:
		 * - incomplete 4-byte sequence
		 * - overlong encoding of ASCII, 2-byte, or 3-byte code point
		 * - code point exceeds U+10FFFF
		 * - code point is U+xxFFFE or U+xxFFFF
		 */
		if (p + 4 > stop || !UTF8_IS_EXT(p[1])
				|| !UTF8_IS_EXT(p[2]) || !UTF8_IS_EXT(p[3]) 
				|| (*p == 0xF0 && p[1] < 0x90)
				|| (*p == 0xF4 && p[1] >= 0x90)
				|| ((p[1] & 0xF) == 0xF && p[2] == 0xBF && p[3] >= 0xBE))
			goto malformed;

		/* well-formed 4-byte sequence */
		p += 4;
		continue;

malformed:
		++errors;
		if (replace)
			*p++ = UTF8_REPLACE;
	}
#ifdef ZOS
	convert_atoe_l(buf, len);
#endif /* ZOS */
	return errors;
}


/* For native encodings, we should be able to assume that we are at
 * a character boundary when we see a value less than 0x20, because
 * all of the character sets leave the control character range intact.
 * We don't know anything else about the structure of the code page,
 * so we make no other assumptions.
 */
size_t convert_native_find_boundary(const char *in, size_t inlen)
{
	register const char *p;

	for (p = &in[inlen-1]; p >= in; --p) {
		if ((unsigned char)(*p) < 0x20)
			return (p - in) + 1;
	}
	return 0;
}

#ifdef WIN32

/* We can assume a wide character boundary anywhere except after a high
 * surrogate for which we do not know the next value.
 */
size_t convert_wide_find_boundary(const wchar_t *in, size_t inlen)
{
	if (inlen > 0) {
		wchar_t c = in[inlen - 1];
		return (c < 0xD800 || c >= 0xDC00) ? inlen : (inlen - 1);
	}
	else return 0;
}
#endif /* WIN32 */

